
# -*- encoding:utf-8 -*-
# rb2html
# Copyright (c) 2001, 2004, 2006 HORIKAWA Hisashi. All rights reserved.
#     http://www.nslabs.jp/
#     mailto:vzw00011@nifty.ne.jp

module Rb2HTML
  class Factory
    TARGETS = {
      ['ruby', '.rb'] => :Ruby2Html,
      ['c', 'c++', '.c', '.cpp', '.cc', '.cxx', '.h', '.m'] => :Cpp2Html,
      ['java', '.java'] => :Java2Html,
      ['python', '.py'] => :Python2Html,
      ['html', 'xhtml', '.htm', '.html'] => :Html2Html,
      ['xml', '.xml', '.rdf'] => :Xml2Html
    }

    # 入力
    #     lang 言語名 or 拡張子
    def Factory.get_formatter lang, layout
      TARGETS.each {|pat, klass|
        if pat.include?(lang.downcase)
          require 'rb2html/' + klass.to_s.downcase
          return module_eval(klass.to_s).new(layout)
        end
      }
      raise ArgumentError
    end
  end
end # of module Rb2HTML
